// C++ header file flame_front.hpp

/*
  By Nathan C. Hearn
     November 20, 2007

  Naive method for approximating the flame front position.
*/


#ifndef FLAME_FRONT_HPP
#define FLAME_FRONT_HPP


#include "quickflash_file_datafile.hpp"


double find_flame_front_sample(const QuickFlash::File::DataFile & df, 
			       const double flame_level,
			       const unsigned int max_search_level, 
			       const unsigned int axis_sample_points,
			       double & volume_min_x, double & volume_max_x);


void find_flame_range_sample(const QuickFlash::File::DataFile & df, 
			     const double min_flame_level, 
			     const double max_flame_level, 
			     const unsigned int max_search_level, 
			     const unsigned int axis_sample_points,
			     double & flame_min_x, double & flame_max_x);


int get_flame_bounds(const QuickFlash::File::DataFile & df,
		     const double min_flame_value,
		     const double max_flame_value,
		     double & min_flame_x, double & max_flame_x);



#endif  // FLAME_FRONT_HPP
