// C++ header file layer_detection.hpp

/*
  By Nathan C. Hearn
     October 31, 2007

  Layer detection utilities.
*/


#ifndef LAYER_DETECTION_HPP
#define LAYER_DETECTION_HPP


#include <vector>


int find_bubble_trough_poly_dens_power(const std::vector<double> & cell_pos,
				       const std::vector<double> & power_ratio,
				       const double target_power_ratio,
				       double & bubble_position);

int find_spike_tip_poly_dens_wavenumber(const std::vector<double> & cell_pos,
					const std::vector<double> & avg_poly,
					const double min_poly,
			 const std::vector<unsigned int> & dominant_wavenumber,
					const unsigned int target_wavenumber,
					double & start_poly_pos, 
					double & spike_pos);
		   

int find_spike_tip_poly_dens(const std::vector<double> & cell_pos,
			     const std::vector<double> & avg_poly,
			     const double start_poly,
			     const std::vector<double> & avg_poly_dens,
			     const std::vector<double> & power_ratio,
			     double & start_poly_pos, double & spike_pos);
		   


#endif  // LAYER_DETECTION_HPP
