// C++ header file layer_detection.hpp

/*
  By Nathan C. Hearn
     April 3, 2008

  Layer detection routines for analyzing simulations of Omega RT experiments.
*/


#ifndef LAYER_DETECTION_HPP
#define LAYER_DETECTION_HPP


#include <string>
#include <vector>
#include "quickflash_file_datafile.hpp"


int find_maximal_envelope(const QuickFlash::File::DataFile & df,
			  const std::string & dataset_name,
			  const unsigned int search_axis,
			  const double min_data_value,
			  const double max_data_value,
			  double & min_coord, double & max_coord,
			  const bool limit_sample_radius=false,
			  const double max_sample_radius=0.0);


int find_layer_bounds_product(const std::vector<double> & bin_centers,
			      const double peak_product_fraction,
			      const std::vector<double> & poly_mass_bins,
			      const std::vector<double> & chbr_mass_bins,
			      const std::vector<double> & foam_mass_bins,
			      bool & found_min_layer_coord,
			      double & min_layer_coord, 
			      bool & found_max_layer_coord,
			      double & max_layer_coord);


int find_threshold_trans(const std::vector<double> & value_list,
			 const double threshold_value,
			 unsigned int & prev_index, 
			 double & thresh_prev_next_fract,
			 const bool forward=true);


#endif  // LAYER_DETECTION_HPP
