# particle_reader.py

# By Nathan C. Hearn
#    August 1, 2007
#
# Reader component encapsulator for QuickFlash library


from quickflash import PartData, Datafile


class ParticleReader(PartData) :

    def __init__(self, filename=None) :

        self.__data_file = None

        self.__sim_info = None

        PartData.__init__(self)

        self.reset(filename)


    def reset(self, filename=None) :

        self.__data_file = None
        
        self.__sim_info = None

        PartData.reset(self)

        if (filename is not None) :

            self.__data_file = Datafile(filename)

            self.__sim_info = self.__data_file.get_sim_info()

            PartData.reset(self, self.__data_file.get_part_data())


    def get_sim_time(self) :
        return self.__sim_info.get_sim_time()
