#!/usr/bin/python

from sys import stdout

from ParTask import MPI_Active, MPI_Rank, MPI_Size, MPI_Root

my_role = None
num_threads = int(1)

if (MPI_Active) :
    print "MPI active -- process [ " + str(MPI_Rank) + " ] of [ " \
          + str(MPI_Size) + " ]"
    

if ((MPI_Root == MPI_Rank) or (not MPI_Active)) :
    input_file = "voltasks_mpi.pre"
    output_file = "voltasks_mpi.post"
    
    # I am the server

    from ParTask import Server

    my_role = Server(input_file, output_file, num_threads, use_threads=False)
else :
    from ParTask import Client

    my_role = Client(num_threads, use_threads=False)

my_role.run()

print "Tasks finished -- rank [ " + str(MPI_Rank) + " ]"

if (MPI_Active) :
    import mpi
    mpi.barrier()

