# numeric_defs.py

# By Nathan C. Hearn
#    November 29, 2008
#
# Numeric definitions

# The following is a kludge to make use of the existing numerics package

numeric_zeros = None
numeric_array = None

numeric_int = None
numeric_float = None
numeric_cplx = None

numeric_transpose = None

numeric_fft = None
numeric_fft_real = None



try :
    
    import numpy
    
    numeric_zeros = numpy.zeros
    numeric_array = numpy.array
    
    numeric_int = numpy.int
    numeric_float = numpy.float
    numeric_cplx = numpy.complex
    
    numeric_transpose = numpy.transpose

    numeric_fft = numpy.fft.fft
    numeric_fft_real = numpy.fft.rfft
    
except ImportError :
    
    import Numeric
    import FFT
    
    numeric_zeros = Numeric.zeros
    numeric_array = Numeric.array
    
    numeric_int = Numeric.Int
    numeric_float = Numeric.Float
    numeric_cplx = Numeric.Complex
    
    numeric_transpose = Numeric.transpose

    numeric_fft = Numeric.fft
    numeric_fft_real = FFT.real_fft

